rpmts.h File Reference
(un)Installing packages: » Transaction Set API.
`#include <sys/types.h>`
`#include <rpm/rpmtypes.h>`
`#include <rpm/rpmte.h>`
`#include <rpm/rpmps.h>`
`#include <rpm/rpmsw.h>`
`#include <rpm/rpmpgp.h>`
`#include <rpm/rpmfi.h>`
`#include <rpm/rpmcallback.h>`
Include dependency graph for rpmts.h:

Go to the source code of this file.

## Macros

#define | _noTransScripts
#define | _noTransTriggers
#define | RPMTRANS_FLAG_NOPAYLOAD 0
#define | RPMTRANS_FLAG_APPLYONLY 0
#define | RPMTRANS_FLAG_KEEPOBSOLETE 0
#define | RPMTRANS_FLAG_DIRSTASH 0
#define | RPMTRANS_FLAG_REPACKAGE 0
#define | RPMTRANS_FLAG_PKGCOMMIT 0
#define | RPMTRANS_FLAG_PKGUNDO 0
#define | RPMTRANS_FLAG_COMMIT 0
#define | RPMTRANS_FLAG_UNDO 0
#define | RPMTRANS_FLAG_REVERSE 0
#define | RPMTRANS_FLAG_NOSUGGEST 0
#define | RPMTRANS_FLAG_ADDINDEPS 0
#define | RPMVSF_MASK_NODIGESTS
#define | _RPMVSF_NODIGESTS RPMVSF_MASK_NODIGESTS
#define | RPMVSF_MASK_NOSIGNATURES
#define | _RPMVSF_NOSIGNATURES RPMVSF_MASK_NOSIGNATURES
#define | RPMVSF_MASK_NOHEADER
#define | _RPMVSF_NOHEADER RPMVSF_MASK_NOHEADER
#define | RPMVSF_MASK_NOPAYLOAD
#define | _RPMVSF_NOPAYLOAD RPMVSF_MASK_NOPAYLOAD
#define | RPMSIG_VERIFIABLE_TYPE (RPMSIG_DIGEST_TYPE|RPMSIG_SIGNATURE_TYPE)
#define | RPMSIG_UNVERIFIED_TYPE (1 << 30)

## Typedefs

typedef rpmFlags | rpmtransFlags
typedef rpmFlags | rpmVSFlags
typedef enum rpmtsOpX_e | rpmtsOpX
typedef rpmFlags | rpmtxnFlags

## Enumerations

enum

rpmtransFlags_e {
RPMTRANS_FLAG_NONE = 0, RPMTRANS_FLAG_TEST = (1 << 0), RPMTRANS_FLAG_BUILD_PROBS = (1 << 1), RPMTRANS_FLAG_NOSCRIPTS = (1 << 2),
RPMTRANS_FLAG_JUSTDB = (1 << 3), RPMTRANS_FLAG_NOTRIGGERS = (1 << 4), RPMTRANS_FLAG_NODOCS = (1 << 5), RPMTRANS_FLAG_ALLFILES = (1 << 6),
RPMTRANS_FLAG_NOPLUGINS = (1 << 7), RPMTRANS_FLAG_NOCONTEXTS = (1 << 8), RPMTRANS_FLAG_NOCAPS = (1 << 9), RPMTRANS_FLAG_NOTRIGGERPREIN = (1 << 16),
RPMTRANS_FLAG_NOPRE = (1 << 17), RPMTRANS_FLAG_NOPOST = (1 << 18), RPMTRANS_FLAG_NOTRIGGERIN = (1 << 19), RPMTRANS_FLAG_NOTRIGGERUN = (1 << 20),
RPMTRANS_FLAG_NOPREUN = (1 << 21), RPMTRANS_FLAG_NOPOSTUN = (1 << 22), RPMTRANS_FLAG_NOTRIGGERPOSTUN = (1 << 23), RPMTRANS_FLAG_NOPRETRANS = (1 << 24),
RPMTRANS_FLAG_NOPOSTTRANS = (1 << 25), RPMTRANS_FLAG_NOMD5 = (1 << 27), RPMTRANS_FLAG_NOFILEDIGEST = (1 << 27), RPMTRANS_FLAG_NOARTIFACTS = (1 << 29),
RPMTRANS_FLAG_NOCONFIGS = (1 << 30), RPMTRANS_FLAG_DEPLOOPS = (1 << 31)
}

enum | rpmVSFlags_e { RPMVSF_DEFAULT = 0, RPMVSF_NOHDRCHK = (1 << 0), RPMVSF_NEEDPAYLOAD = (1 << 1), RPMVSF_NOSHA1HEADER = (1 << 8), RPMVSF_NOSHA256HEADER = (1 << 9), RPMVSF_NODSAHEADER = (1 << 10), RPMVSF_NORSAHEADER = (1 << 11), RPMVSF_NOPAYLOAD = (1 << 16), RPMVSF_NOMD5 = (1 << 17), RPMVSF_NODSA = (1 << 18), RPMVSF_NORSA = (1 << 19) }
enum | { RPMSIG_NONE_TYPE = 0, RPMSIG_DIGEST_TYPE = (1 << 0), RPMSIG_SIGNATURE_TYPE = (1 << 1), RPMSIG_OTHER_TYPE = (1 << 2) }

enum

rpmtsOpX_e {
RPMTS_OP_TOTAL = 0, RPMTS_OP_CHECK = 1, RPMTS_OP_ORDER = 2, RPMTS_OP_FINGERPRINT = 3,
RPMTS_OP_INSTALL = 5, RPMTS_OP_ERASE = 6, RPMTS_OP_SCRIPTLETS = 7, RPMTS_OP_COMPRESS = 8,
RPMTS_OP_UNCOMPRESS = 9, RPMTS_OP_DIGEST = 10, RPMTS_OP_SIGNATURE = 11, RPMTS_OP_DBADD = 12,
RPMTS_OP_DBREMOVE = 13, RPMTS_OP_DBGET = 14, RPMTS_OP_DBPUT = 15, RPMTS_OP_DBDEL = 16,
RPMTS_OP_VERIFY = 17, RPMTS_OP_MAX = 18
}

enum | rpmtxnFlags_e { RPMTXN_READ = (1 << 0), RPMTXN_WRITE = (1 << 1) }

## Functions

int | rpmtsCheck (rpmts ts)
int | rpmtsOrder (rpmts ts)
int | rpmtsRun (rpmts ts, rpmps okProbs, rpmprobFilterFlags ignoreSet)
rpmts | rpmtsLink (rpmts ts)
int | rpmtsCloseDB (rpmts ts)
int | rpmtsOpenDB (rpmts ts, int dbmode)
int | rpmtsInitDB (rpmts ts, int dbmode)
int | rpmtsGetDBMode (rpmts ts)
int | rpmtsSetDBMode (rpmts ts, int dbmode)
int | rpmtsRebuildDB (rpmts ts)
int | rpmtsVerifyDB (rpmts ts)
rpmdbMatchIterator | rpmtsInitIterator (const rpmts ts, rpmDbiTagVal rpmtag, const void *keyp, size_t keylen)
rpmRC | rpmtsImportHeader (rpmtxn txn, Header h, rpmFlags flags)
rpmRC | rpmtsImportPubkey (rpmts ts, const unsigned char *pkt, size_t pktlen)
rpmKeyring | rpmtsGetKeyring (rpmts ts, int autoload)
int | rpmtsSetKeyring (rpmts ts, rpmKeyring keyring)
int | rpmtsSetSolveCallback (rpmts ts, int(*solve)(rpmts ts, rpmds ds, const void *data), const void *solveData)
rpmps | rpmtsProblems (rpmts ts)
void | rpmtsCleanProblems (rpmts ts)
void | rpmtsClean (rpmts ts)
void | rpmtsEmpty (rpmts ts)
rpmts | rpmtsFree (rpmts ts)
rpmVSFlags | rpmtsVSFlags (rpmts ts)
rpmVSFlags | rpmtsSetVSFlags (rpmts ts, rpmVSFlags vsflags)
rpmVSFlags | rpmtsVfyFlags (rpmts ts)
rpmVSFlags | rpmtsSetVfyFlags (rpmts ts, rpmVSFlags vfyflags)
int | rpmtsVfyLevel (rpmts ts)
int | rpmtsSetVfyLevel (rpmts ts, int vfylevel)
const char * | rpmtsRootDir (rpmts ts)
int | rpmtsSetRootDir (rpmts ts, const char *rootDir)
FD_t | rpmtsScriptFd (rpmts ts)
void | rpmtsSetScriptFd (rpmts ts, FD_t scriptFd)
rpm_tid_t | rpmtsGetTid (rpmts ts)
rpm_tid_t | rpmtsSetTid (rpmts ts, rpm_tid_t tid)
rpmdb | rpmtsGetRdb (rpmts ts)
void * | rpmtsNotify (rpmts ts, rpmte te, rpmCallbackType what, rpm_loff_t amount, rpm_loff_t total)
int | rpmtsNElements (rpmts ts)
rpmte | rpmtsElement (rpmts ts, int ix)
rpmprobFilterFlags | rpmtsFilterFlags (rpmts ts)
rpmtransFlags | rpmtsFlags (rpmts ts)
rpmtransFlags | rpmtsSetFlags (rpmts ts, rpmtransFlags transFlags)
rpm_color_t | rpmtsColor (rpmts ts)
rpm_color_t | rpmtsPrefColor (rpmts ts)
rpm_color_t | rpmtsSetColor (rpmts ts, rpm_color_t color)
rpm_color_t | rpmtsSetPrefColor (rpmts ts, rpm_color_t color)
rpmop | rpmtsOp (rpmts ts, rpmtsOpX opx)
rpmPlugins | rpmtsPlugins (rpmts ts)
int | rpmtsSetNotifyCallback (rpmts ts, rpmCallbackFunction notify, rpmCallbackData notifyData)
rpmts | rpmtsCreate (void)
int | rpmtsAddInstallElement (rpmts ts, Header h, const fnpyKey key, int upgrade, rpmRelocation *relocs)
int | rpmtsAddReinstallElement (rpmts ts, Header h, const fnpyKey key)
int | rpmtsAddEraseElement (rpmts ts, Header h, int dboffset)
rpmtxn | rpmtxnBegin (rpmts ts, rpmtxnFlags flags)
rpmtxn | rpmtxnEnd (rpmtxn txn)
rpmtsi | rpmtsiFree (rpmtsi tsi)
rpmtsi | rpmtsiInit (rpmts ts)
rpmte | rpmtsiNext (rpmtsi tsi, rpmElementTypes types)

## Variables

int | _rpmts_stats

## Detailed Description

Structures and prototypes used for an "rpmts" transaction set.

Definition in file rpmts.h.

## Macro Definition Documentation

## _noTransScripts

#define _noTransScripts

Value:
( RPMTRANS_FLAG_NOPRE | \
RPMTRANS_FLAG_NOPOST | \
RPMTRANS_FLAG_NOPREUN | \
RPMTRANS_FLAG_NOPOSTUN | \
RPMTRANS_FLAG_NOPRETRANS | \
RPMTRANS_FLAG_NOPOSTTRANS \
)

Definition at line 63 of file rpmts.h.

## _noTransTriggers

#define _noTransTriggers

Value:
( RPMTRANS_FLAG_NOTRIGGERPREIN | \
RPMTRANS_FLAG_NOTRIGGERIN | \
RPMTRANS_FLAG_NOTRIGGERUN | \
RPMTRANS_FLAG_NOTRIGGERPOSTUN \
)

Definition at line 72 of file rpmts.h.

## _RPMVSF_NODIGESTS

#define _RPMVSF_NODIGESTS RPMVSF_MASK_NODIGESTS

Definition at line 120 of file rpmts.h.

## _RPMVSF_NOHEADER

#define _RPMVSF_NOHEADER RPMVSF_MASK_NOHEADER

Definition at line 134 of file rpmts.h.

## _RPMVSF_NOPAYLOAD

#define _RPMVSF_NOPAYLOAD RPMVSF_MASK_NOPAYLOAD

Definition at line 141 of file rpmts.h.

## _RPMVSF_NOSIGNATURES

#define _RPMVSF_NOSIGNATURES RPMVSF_MASK_NOSIGNATURES

Definition at line 127 of file rpmts.h.

## RPMSIG_UNVERIFIED_TYPE

#define RPMSIG_UNVERIFIED_TYPE (1 << 30)

Definition at line 151 of file rpmts.h.

## RPMSIG_VERIFIABLE_TYPE

#define RPMSIG_VERIFIABLE_TYPE (RPMSIG_DIGEST_TYPE|RPMSIG_SIGNATURE_TYPE)

Definition at line 150 of file rpmts.h.

## RPMTRANS_FLAG_ADDINDEPS

#define RPMTRANS_FLAG_ADDINDEPS 0

Definition at line 91 of file rpmts.h.

## RPMTRANS_FLAG_APPLYONLY

#define RPMTRANS_FLAG_APPLYONLY 0

Definition at line 81 of file rpmts.h.

## RPMTRANS_FLAG_COMMIT

#define RPMTRANS_FLAG_COMMIT 0

Definition at line 87 of file rpmts.h.

## RPMTRANS_FLAG_DIRSTASH

#define RPMTRANS_FLAG_DIRSTASH 0

Definition at line 83 of file rpmts.h.

## RPMTRANS_FLAG_KEEPOBSOLETE

#define RPMTRANS_FLAG_KEEPOBSOLETE 0

Definition at line 82 of file rpmts.h.

## RPMTRANS_FLAG_NOPAYLOAD

#define RPMTRANS_FLAG_NOPAYLOAD 0

Definition at line 80 of file rpmts.h.

## RPMTRANS_FLAG_NOSUGGEST

#define RPMTRANS_FLAG_NOSUGGEST 0

Definition at line 90 of file rpmts.h.

## RPMTRANS_FLAG_PKGCOMMIT

#define RPMTRANS_FLAG_PKGCOMMIT 0

Definition at line 85 of file rpmts.h.

## RPMTRANS_FLAG_PKGUNDO

#define RPMTRANS_FLAG_PKGUNDO 0

Definition at line 86 of file rpmts.h.

## RPMTRANS_FLAG_REPACKAGE

#define RPMTRANS_FLAG_REPACKAGE 0

Definition at line 84 of file rpmts.h.

## RPMTRANS_FLAG_REVERSE

#define RPMTRANS_FLAG_REVERSE 0

Definition at line 89 of file rpmts.h.

## RPMTRANS_FLAG_UNDO

#define RPMTRANS_FLAG_UNDO 0

Definition at line 88 of file rpmts.h.

## RPMVSF_MASK_NODIGESTS

#define RPMVSF_MASK_NODIGESTS

Value:
( RPMVSF_NOSHA1HEADER | \
RPMVSF_NOSHA256HEADER | \
RPMVSF_NOPAYLOAD | \
RPMVSF_NOMD5 )

Definition at line 115 of file rpmts.h.

## RPMVSF_MASK_NOHEADER

#define RPMVSF_MASK_NOHEADER

Value:
( RPMVSF_NOSHA1HEADER | \
RPMVSF_NOSHA256HEADER | \
RPMVSF_NODSAHEADER | \
RPMVSF_NORSAHEADER )

Definition at line 129 of file rpmts.h.

## RPMVSF_MASK_NOPAYLOAD

#define RPMVSF_MASK_NOPAYLOAD

Value:
( RPMVSF_NOMD5 | \
RPMVSF_NOPAYLOAD | \
RPMVSF_NODSA | \
RPMVSF_NORSA )

Definition at line 136 of file rpmts.h.

## RPMVSF_MASK_NOSIGNATURES

#define RPMVSF_MASK_NOSIGNATURES

Value:
( RPMVSF_NODSAHEADER | \
RPMVSF_NORSAHEADER | \
RPMVSF_NODSA | \
RPMVSF_NORSA )

Definition at line 122 of file rpmts.h.

## Typedef Documentation

## rpmtransFlags

typedef rpmFlags rpmtransFlags

Definition at line 60 of file rpmts.h.

## rpmtxnFlags

typedef rpmFlags rpmtxnFlags

Definition at line 180 of file rpmts.h.

## rpmVSFlags

typedef rpmFlags rpmVSFlags

Definition at line 112 of file rpmts.h.

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
RPMSIG_NONE_TYPE |
RPMSIG_DIGEST_TYPE |
RPMSIG_SIGNATURE_TYPE |
RPMSIG_OTHER_TYPE |

Definition at line 142 of file rpmts.h.

## rpmtxnFlags_e

enum rpmtxnFlags_e

Enumerator
RPMTXN_READ |
RPMTXN_WRITE |

Definition at line 176 of file rpmts.h.

## Variable Documentation

## _rpmts_stats

int _rpmts_stats

RPMVSF_NODSAHEADER
@ RPMVSF_NODSAHEADER
Definition: rpmts.h:102
RPMVSF_NOSHA1HEADER
@ RPMVSF_NOSHA1HEADER
Definition: rpmts.h:100
RPMTRANS_FLAG_NOTRIGGERPREIN
@ RPMTRANS_FLAG_NOTRIGGERPREIN
Definition: rpmts.h:41
RPMTRANS_FLAG_NOPRE
@ RPMTRANS_FLAG_NOPRE
Definition: rpmts.h:42
RPMVSF_NOMD5
@ RPMVSF_NOMD5
Definition: rpmts.h:106